<template>
  <div
    class="drag-drop"
    :class="{ active: isActive }"
    @click="selectFiles"
    @dragenter.prevent="isActive = true"
    @dragover.prevent="isActive = true"
    @dragleave.prevent="checkActive($event)"
    @drop.prevent="uploadFiles"
  >
    <div class="drag-drop__placeholder">
      <div class="drag-drop__headtext">Загрузить файл</div>
      <div class="drag-drop__text" v-show="!isActive">
        Выберите или перетащите один или несколько файлов
      </div>
      <div class="drag-drop__text" v-show="isActive">
        Отпустите файлы в этой зоне чтобы загрузить их
      </div>
    </div>
  </div>
  <input
    type="file"
    id="fileEngine"
    ref="fileEngine"
    @change="serializeData"
    multiple
  />
</template>
<script>
export default {
  name: "AppDragDrop",
  components: {},
  data() {
    return {
      isActive: false,
    };
  },
  props: {},
  emits: ["change"],
  methods: {
    selectFiles() {
      this.$refs.fileEngine?.click();
    },
    serializeData(e) {
      // console.log(e);
      this.$emit("change", e.target.files);
    },
    uploadFiles(e) {
      if (e.dataTransfer.files.length) {
        this.$emit("change", e.dataTransfer.files);
        this.isActive = false;
      }
    },
    checkActive(e) {
      if (
        (e.fromElement?.classList[0] === "container" &&
          e.toElement?.classList[0] === "drag-drop") ||
        (e.fromElement?.classList[0] === "frame" &&
          e.toElement?.classList[0] === "drag-drop") ||
        (e.fromElement?.classList[0] === undefined && e.toElement?.classList[0])
      ) {
        this.isActive = false;
      } else {
        this.isActive = true;
      } //Нужно для того чтобы не дергалась активность при перемещении курсора с файлом

      // console.log(e.fromElement?.classList[0], e.toElement?.classList[0]);
    },
  },
};
</script>
<style>
.drag-drop {
  width: 100%;
  height: 200px;
  background: #f6f6f6;
  border: 2px dashed #dfe3e7;
  border-radius: 6px;
  position: relative;
  cursor: pointer;
  margin-bottom: 10px;
}

.drag-drop .drag-drop__placeholder {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  text-align: center;
  font-weight: 500;
  user-select: none;
}

.drag-drop .drag-drop__placeholder .drag-drop__headtext {
  font-size: 14px;
  line-height: 14px;
  color: #82898f;
  margin-bottom: 6px;
}

.drag-drop .drag-drop__placeholder .drag-drop__text {
  font-size: 10px;
  color: #82898f;
  line-height: 13px;
}

.drag-drop.active {
  background: #fafafa;
}
</style>
